//@author: mholub
//@help: naive histogram calculation
//@tags: 
//@credits: 

RWStructuredBuffer<uint> RWValueBuffer : BACKBUFFER;

int2 Size;
Texture2D<float4> texture2d <string uiname="Texture";>;

[numthreads(256,1,1)]
void Clear_CS(uint3 dtid : SV_DispatchThreadID)
{
	uint idx = dtid.x;
	if (idx < 256) 
		RWValueBuffer[idx] = 0;	
}

[numthreads(128,1,1)]
void CS(uint3 dtid : SV_DispatchThreadID)
{
	uint idx = dtid.x;
	uint3 uv = uint3(idx % Size.x, idx / Size.x, 0);
	
	InterlockedAdd(RWValueBuffer[dot(texture2d.Load(uv).rgb, float3(0.3, 0.59, 0.11)) * 256], 1);
}

technique11 clear
{
	pass P0
	{
		SetComputeShader( CompileShader( cs_5_0, Clear_CS() ) );
	}
}

technique11 naive_histo
{
	pass P1
	{
		SetComputeShader( CompileShader( cs_5_0, CS() ) );
	}
}
